package com.loit.shardingsphere.seata.nacos.feign.modules.service.impl;

import com.loit.shardingsphere.seata.nacos.feign.modules.entity.OrderEntity;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IBusinessService;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IOrderService;
import io.seata.spring.annotation.GlobalTransactional;
import org.apache.shardingsphere.transaction.annotation.ShardingTransactionType;
import org.apache.shardingsphere.transaction.core.TransactionType;
import org.apache.shardingsphere.transaction.core.TransactionTypeHolder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("businessService")
public class BusinessServiceImpl implements IBusinessService {

    @Autowired
    IOrderService orderService;

    @Override
    @ShardingTransactionType(TransactionType.BASE)
    @GlobalTransactional
    public void purchase(Long userId) {
        if (userId == null) {
            return;
        }
        TransactionTypeHolder.set(TransactionType.BASE);
        OrderEntity orderEntity = new OrderEntity();
        orderEntity.setOrderId(userId);
        orderEntity.setStatus("seata");
        orderEntity.setUserId(userId.intValue());
        orderService.insertOrder(orderEntity);
        //throw new RuntimeException("回滚测试");
    }

}
